//+------------------------------------------------------------------+
//|                                                  RSIExtremes.mq4 |
//|                                                             Maji |
//+------------------------------------------------------------------+
#property copyright "Maji"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/2523-i-want-make-expret.html"

extern double Lots=1.0;
extern int Slippage=3;
extern int TradesMax=1;

extern int StopLoss=30;
//extern int TrailingStop=20;
extern int TakeProfit=0;

extern int RSIPeriod=4;

extern double RSIBuyLevel=10.0;
extern double RSIBuyClose=90.0;
extern double RSISellLevel=90.0;
extern double RSISellClose=10.0;
extern int RSIPrice = PRICE_CLOSE;

extern int MAPeriod=50;
extern int MAShift=0;
extern int MAMethod=MODE_SMA;
extern int MAPrice=PRICE_CLOSE;

extern int TimeFrame = 5;

bool runnable=true;
bool init=true;
int MagicNumber=145;
datetime timeprev=0;
string EAName = "RSIExtremes";
int init()
{
 MagicNumber = MagicfromSymbol();
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
//Runnable
 if(runnable!=true)
  return(-1);
  

//
//Close/Open
//
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
//Indicators
 double RSI01=iRSI(NULL,TimeFrame,RSIPeriod,RSIPrice,1);
 double RSI02=iRSI(NULL,TimeFrame,RSIPeriod,RSIPrice,2);
 double MA=iMA(NULL,TimeFrame,MAPeriod,MAShift,MAMethod,MAPrice,1);

// double RSI01=iCustom(NULL,0,"RSIofCCI",RSIPeriod,CCIPeriod, 0, 1);
// double RSI02=iCustom(NULL,0,"RSIofCCI",RSIPeriod,CCIPeriod, 0, 2);
 

//
//Close Trades
//

//Long
 if(CountLongs()>0 && RSI01>=RSIBuyClose)
 {
  CloseLongs();
 }//Long
 
//Shrt
 if(CountShrts()>0 && RSI01<=RSISellClose)
 {
  CloseShrts();
 }//Shrt
 
//
//Open Trades
//

//Long
// if(CountLongs()<TradesMax && RSI01<=RSIBuyLevel && Close[1]>MA)
 if(CountLongs()<TradesMax && RSI01<=RSIBuyLevel)
 {
  CloseShrts();
  OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,StopLong(Bid,StopLoss),TakeLong(Ask,TakeProfit),EAName,MagicNumber,0,Blue);
 }//Long
 
// if(CountShrts()<TradesMax && RSI01>=RSISellLevel && Close[1]<MA)
 if(CountShrts()<TradesMax && RSI01>=RSISellLevel)
 {
  CloseLongs();
  OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopShrt(Ask,StopLoss),TakeShrt(Bid,TakeProfit),EAName,MagicNumber,0,Red);
 }//Shrt

 return(0);
}


int CountLongs()
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  if(OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}

int CountShrts()
{
 int count=0;
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  if(OrderType()==OP_SELL)
   count++;
 }//for
 return(count);
}

void CloseLongs()
{
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  if(OrderType()==OP_BUY)
   OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
 }//for
}

void CloseShrts()
{
 int trade;
 int trades=OrdersTotal();
 for(trade=0;trade<trades;trade++)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  if(OrderType()==OP_SELL)
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
 }//for
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShrt(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShrt(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}

int MagicfromSymbol() {
   int magic=0;
   for (int i=0; i<6; i++) { 
      magic=magic*7+StringGetChar(Symbol(),i);
   }
   magic=magic*3+Period();
   return(magic);
}

